$BSD_iconWidth = 96;

package BrickSelectorResizeIcons
{
	function BSD_LoadBricks()
	{
		parent::BSD_LoadBricks();

		%value = $Pref::Client::BSD_iconsPerRow;
		if(%value $= "")
			%value = 6;

		if(!isObject(BSD_ResizeSlider))
		{
			new GuiSliderCtrl(BSD_ResizeSlider)
			{
				profile = "BlockButtonProfile";
				position = "477 4";
				extent = "128 18";
				altCommand = "BSD_OnResizeSliderMoved();";
				range = "3 16";
				ticks = "12";
				value = %value;
				snap = "1";
			};
			BSD_Window.add(BSD_ResizeSlider);
		}

		BSD_SetIconsPerRow(%value);
	}
};
activatePackage(BrickSelectorResizeIcons);

function BSD_OnResizeSliderMoved()
{
	%value = BSD_ResizeSlider.getValue();
	if(%value != $Pref::Client::BSD_iconsPerRow)
		BSD_SetIconsPerRow(%value);
}

function BSD_SetIconsPerRow(%num)
{
	%width = 581;
	%withoutspacers = %width - %num + 1;

	%smaller = mFloor(%withoutspacers / %num);
	%larger = mCeil(%withoutspacers / %num);

	%smallerDiff = mAbs(%withoutspacers - (%smaller * %num));
	%largerDiff = mAbs(%withoutspacers - (%larger * %num));

	if(%smallerDiff < %largerDiff)
		$BSD_iconWidth = %smaller;
	else
		$BSD_iconWidth = %larger;

	$Pref::Client::BSD_iconsPerRow = %num;
	BSD_RescaleIcons();
}

function BSD_RescaleIcons()
{
	for(%i = 0; %i < $BSD_numCategories; %i++)
	{
		%cat = $BSD_category[%i];
		%box = %cat.box;
		%box.clear();
		%box.resize(0,0,0,0);

		for(%j = 0; %j < %cat.numSubCategories; %j++)
		{
			%subCatObj = %cat.subCategory[%j];
			%boxExtent = %box.getExtent();
			%boxMinExtent = %box.getMinExtent();
			%boxHeight = getWord(%boxExtent, 1) - getWord(%boxMinExtent, 1);
			%subCatObj.startHeight = %boxHeight;
			%subCatObj.numBrickButtons = 0;

			%newBar = new GuiBitmapCtrl()
			{
				keepCached = 1;
				position = 18 SPC (%subCatObj.startHeight + 15);
				extent = "581 1";
			};
			%box.add(%newBar);

			%newHeading = new GuiTextCtrl()
			{
				profile = BrickListSubCategoryProfile;
				text = %subCatObj.name;
				position = 28 SPC (%subCatObj.startHeight - 2);
				extent = "100 18";
			};
			%box.add(%newHeading);

			%box.resize(0, 0, 634, %boxHeight + 18 + (mCeil(%subCatObj.numBricks / $Pref::Client::BSD_iconsPerRow) * $BSD_iconWidth) + 5);
		}
	}

	for(%i = 0; %i < getDataBlockGroupSize(); %i++)
	{
		%data = getDataBlock(%i);
		if(%data.getClassName() $= "fxDTSBrickData")
		{
			%catObj = BSD_findCategory(%data.category);
			%subCatObj = BSD_findSubCategory(%catObj, %data.subCategory);

			if(isObject(%catObj) && isObject(%subCatObj) && %data.uiName !$= "")
			{
				%brickName = %data.uiName;
				%brickIcon = %data.iconName;

				if(%brickName $= "")
					%brickName = "No Name";

				%brickIcon = %brickIcon @ ".png";
				if(!isFile(%brickIcon))
					%brickIcon = "base/client/ui/brickIcons/unknown";

				%box = %catObj.box;
				%x = ((%subCatObj.numBrickButtons % $Pref::Client::BSD_iconsPerRow) * ($BSD_iconWidth + 1)) + 18;
				%y = mFloor(%subCatObj.numBrickButtons / $Pref::Client::BSD_iconsPerRow) * ($BSD_iconWidth + 1) + %subCatObj.startHeight + 18;

				%subCatObj.numBrickButtons++;

				%newIconBG = new GuiBitmapCtrl()
				{
					profile = BlockDefaultProfile;
					position = %x SPC %y;
					extent = $BSD_iconWidth SPC $BSD_iconWidth;
					bitmap = "base/client/ui/brickicons/brickiconbg";
					keepCached = 1;
				};
				%box.add(%newIconBG);

				%newIcon = new GuiBitmapCtrl()
				{
					profile = BlockDefaultProfile;
					position = %x SPC %y;
					extent = $BSD_iconWidth SPC $BSD_iconWidth;
					bitmap = %brickIcon;
					keepCached = 1;
				};
				%box.add(%newIcon);

				%newActive = new GuiBitmapCtrl()
				{
					profile = BlockDefaultProfile;
					position = %x SPC %y;
					extent = $BSD_iconWidth SPC $BSD_iconWidth;
					bitmap = "base/client/ui/brickicons/brickIconActive";
					keepCached = 1;
					visible = 0;
				};
				%box.add(%newActive);
				$BSD_activeBitmap[%data] = %newActive;

				%newLabel = new GuiTextCtrl()
				{
					profile = HUDBSDNameProfile;
					position = %x SPC %y + $BSD_iconWidth - 18;
					extent = $BSD_iconWidth SPC 18;
					text = %brickName;
				};
				%box.add(%newLabel);

				%newIconButton = new GuiBitmapButtonCtrl()
				{
					profile = BlockDefaultProfile;
					position = %x SPC %y;
					extent = $BSD_iconWidth SPC $BSD_iconWidth;
					bitmap = "base/client/ui/brickicons/brickIconBtn";
					text = " ";
					command = "BSD_ClickIcon(" @ %data @ ");";
					altCommand = "BSD_RightClickIcon(" @ %data @ ");";
				};
				%box.add(%newIconButton);
			}
		}
	}
	BSD_ShowTab($BSD_CurrTab);
}